#include <windows.h>
#include <commctrl.h>
#include "fish.h"
#include "compress.hpp"

#define MAXSTR     1024
#define IDC_EDIT1  101
#define IDC_BITMAP 105

#if 1
char a_corrupted[] = "Le fichier est corrompu, passez un anti-virus sur votre systme";
char a_badphrase[] = "Mauvaise phrase de passe";
char a_nooutput[]  = "Impossible de crer le fichier \"%s\" (code %d)";
char a_success[]   = "Dchiffrement russi";
char a_write[]     = "Erreur d'criture sur \"%s\" (code %d)";
char a_cancelled[] = "Opration annule";
char a_outdir[]    = "Choisissez le rpertoire cible";
char a_decrypting[]= "Dchiffrement...";
char a_unzipping[] = "Dcompression...";
char a_cantopen[]  = "Impossible d'ouvrir le fichier chiffr %s (code %d)"; // should not happen
#else
char a_corrupted[] = "The file is corrupted - check your system for viruses";
char a_badphrase[] = "Bad pass phrase";
char a_nooutput[]  = "Could not create output file \"%s\" (code %d)";
char a_success[]   = "Decryption Successful";
char a_write[]     = "Write error on \"%s\" (code %d)";
char a_cancelled[] = "Operation cancelled";
char a_outdir[]    = "Browse to the output directory";
char a_decrypting[]= "Decrypting...";
char a_unzipping[] = "Decompressing...";
char a_cantopen[]  = "Could not open encrypted file %s (code %d)"; // should not happen
#endif

char url[]         = "http://www.acrypt.com";
char appname[]     = "Decrypt";
char wndclass[]    = "DecryptorWindow";

HINSTANCE hinst = 0;

bool BrowseForFolder(HWND hwnd, const char *title, char *buf);
HWND create_hint(HINSTANCE h, HWND hwnd_parent, int x, int y, const char *message);
//----------------------------------------------------------------
static void corrupt(void)
{
  error(a_corrupted);
}

//----------------------------------------------------------------
header_t *get_ct(void)
{
    char infile[MAXSTR];
    GetModuleFileName(NULL, infile, sizeof(infile));
    HANDLE fh = CreateFile(infile, GENERIC_READ, FILE_SHARE_READ,
      NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL);
    if ( fh == INVALID_HANDLE_VALUE )
      error(a_cantopen, infile, GetLastError());
    DWORD fsize = GetFileSize(fh, NULL);
    HANDLE hm = LocalAlloc(LMEM_MOVEABLE, fsize);
    if ( hm == NULL ) nomem("input");
    char *file = (char *)LocalLock(hm);
    DWORD fread;
    ReadFile(fh, file, fsize, &fread, NULL);
    if ( fread != fsize ) error("interr");
    CloseHandle(fh);

    uchar *ptr = (uchar *)file;
    uchar *end = ptr + fsize;

    while ( ptr < end )
    {
      if ( *ptr == uchar(MAGIC) && (*(ulong*)ptr)-1 == MAGIC-1 )
        break;
      ptr++;
    }

    if ( ptr == end )
    {
      corrupt();
      memset(file, 0, sizeof(header_t));        // debug
      return (header_t*)file;                   // debug
    }  

    header_t *h = (header_t *)ptr;

    crc32(NULL, 0);
    ulong scrc32 = crc32(file, (char*)ptr-file);
    if ( scrc32 != h->stub_crc32 ) corrupt();

    if ( (uchar*)(h->h2()) + h->size + ENCRYPTED_SIGN_SIZE != end )
      corrupt();
    return h;
}

//----------------------------------------------------------------
HANDLE create_file(const char *file)
{
  return CreateFile(file, GENERIC_WRITE, 0,
    NULL, CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL);
}

//----------------------------------------------------------------
void get_output_file(HWND h, char *fname)
{
  OPENFILENAME ofn;
  memset(&ofn, 0, sizeof(ofn));
  ofn.lStructSize = sizeof(ofn);
  ofn.hwndOwner   = h;             // WINDOW HANDLER!!!
  ofn.lpstrFile   = fname;
  ofn.nMaxFile    = MAXSTR;
  ofn.Flags       = OFN_HIDEREADONLY|OFN_OVERWRITEPROMPT;
  if ( !GetSaveFileName(&ofn) ) ExitProcess(0);
}

//----------------------------------------------------------------
static HWND hprog = 0;
static HWND pb = 0;
static bool cancelled = false;

static BOOL CALLBACK ProgFunc(HWND , UINT message, WPARAM wp, LPARAM )
{
  switch ( message )
  {
    case WM_INITDIALOG:
      return TRUE;

    case WM_COMMAND:
      switch ( LOWORD(wp) )
      {
        case IDCANCEL:
          cancelled = true;
          return TRUE;
      }
      break;

    case WM_DESTROY:
      PostQuitMessage(0);
      break;  
        
  }
  return FALSE;
}

static void show_progress_bar(HWND hwnd)
{
  hprog = CreateDialog(hinst, MAKEINTRESOURCE(2), hwnd, (DLGPROC)ProgFunc); 
  pb    = GetDlgItem(hprog, 101); 
}

//----------------------------------------------------------------
static void hide_progress_bar(void)
{
//  DestroyWindow(hprog);
  hprog = 0;
  pb    = 0;
}

//----------------------------------------------------------------
static void callback(int type, int cur, int all)
{
  static int otype = -1;
  switch ( type )
  {
    case CB_FISH:
      if ( otype != CB_FISH )
      {
//        SendMessage(pb, PBM_SETRANGE, 0, MAKELPARAM(0, all)); 
        SetWindowText(hprog, a_decrypting);
      }  
      break;
    case CB_ZIP:
      if ( otype != CB_ZIP )
      {
//        SendMessage(pb, PBM_SETRANGE, 0, MAKELPARAM(0, all)); 
        SetWindowText(hprog, a_unzipping);
      }  
      break;
  }
  otype = type;
  SendMessage(pb, PBM_SETPOS, cur*100/all, 0);
}


//----------------------------------------------------------------
static HANDLE of;
static header_t *h;
static header2_t *h2;
static fileh_t *fh;
static uchar *read_ptr;
static size_t unread_bytes;
static size_t written_bytes;
static size_t total_bytes;
static size_t processed_bytes;

//----------------------------------------------------------------
static unsigned mem_read(void *buf, unsigned size)
{
  if ( cancelled ) return 0;
  processed_bytes += size;
  callback(CB_ZIP, processed_bytes, total_bytes);
  if ( size > unread_bytes ) size = unread_bytes;
  memcpy(buf, read_ptr, size);
  read_ptr += size;
  unread_bytes -= size;
  return size;
}

static unsigned file_write(void *buf, unsigned size)
{
  written_bytes += size;
  DWORD written;
  WriteFile(of, buf, size, &written, NULL);
  return written;
}

//----------------------------------------------------------------
static bool dec_callback(int bits)
{
  callback(CB_FISH, bits/8, h->size);
  return !cancelled;
}

//----------------------------------------------------------------
/*
static void init_pasphrase(const char *phrase, cipherInstance *c, keyInstance *k)
{
  uchar hash[KEYSIZE];
  hashpass(phrase, strlen(phrase), hash);
  
  char a[MAX_KEY_SIZE];
  int code = cipherInit(c, MODE_CBC, b2a(h->iv,a));
  if ( code != TRUE ) ERR: error("err%d", code);
  
  code = makeKey(k, DIR_DECRYPT, KEYBITS, b2a(hash,a));
  if ( code != TRUE ) goto ERR;
}
*/

//----------------------------------------------------------------
static void create_subdirs(const char *basedir, char *rest)
{
  while ( (rest=strchr(rest,'\\')) != NULL )
  {
    *rest = '\0';
    CreateDirectory(basedir, NULL);
    *rest = '\\';
    rest++;
  }
}

//----------------------------------------------------------------
static bool process_files(HWND hwnd, const char *phrase)
{
  char fname[MAXSTR];
  uchar test[KEYSIZE+256];
  header2_t *hh2 = (header2_t *)&test;
  int code;
  cipherInstance c;
  keyInstance k;

  // round the length up to next block size
  int bits = h->size * 8;
  bits += BLOCK_SIZE - 1;
  bits &= ~(BLOCK_SIZE - 1);

  uchar hash[KEYSIZE];
  hashpass(phrase, strlen(phrase), hash);

  char a[MAX_KEY_SIZE];
  code = cipherInit(&c, MODE_CBC, b2a(h->iv,a));
  if ( code != TRUE ) ERR: error("err%d", code);

  code = makeKey(&k, DIR_DECRYPT, KEYBITS, b2a(hash,a));
  if ( code != TRUE ) goto ERR;

  // decrypt test block
  code = blockDecrypt(&c, &k, (uchar *)h2, sizeof(test)*8, test, NULL);
  if ( code != sizeof(test)*8 ) goto ERR;
  if (  h->iv[0] != hh2->chk[0]
     || h->iv[1] != hh2->chk[1] )
  {
    warning(a_badphrase);
    return false;
  }

  char *baseptr;
  bool multi = hh2->nfiles > 1;
  if ( multi )
  {
    GetCurrentDirectory(sizeof(fname), fname);
    if ( !BrowseForFolder(hwnd, a_outdir, fname) ) return true;
    baseptr = fname + strlen(fname);
    if ( baseptr[-1] != '\\' ) *baseptr++ = '\\';
  }
  else
  {
    strcpy(fname, hh2->files()->name());
    get_output_file(hwnd, fname);
  }  

  show_progress_bar(hwnd);
  code = blockDecrypt(&c, &k, (uchar *)h2, bits, (uchar *)h2, dec_callback);
  if ( code == BAD_CANCEL ) CANCEL: error(a_cancelled);
  if ( code != bits ) goto ERR;

  fh = h2->files();
  total_bytes = h->size;
  processed_bytes = 0;
  for ( int i=0; i < h2->nfiles; i++, fh=fh->next() )
  {
    if ( multi )
    {
      strcpy(baseptr, fh->name());
      create_subdirs(fname, baseptr);
    }
    of = create_file(fname);
    if ( of == INVALID_HANDLE_VALUE ) error(a_nooutput, fname, GetLastError());
    
    read_ptr = fh->text();
    unread_bytes = fh->csize;
    written_bytes = 0;
    code = unread_bytes ? zip_inflate(mem_read, file_write) : PK_OK;
    if ( cancelled ) goto CANCEL;
    switch ( code )
    {
      case PK_MEM:
        nomem("unzip");
      case PK_WEOF:
        error(a_write, fname, GetLastError());
      default:
        error("interr unzip %d", code);
      case PK_OK:
        break;
    }
    SetFileTime(of, &fh->ctime, &fh->atime, &fh->mtime);
    CloseHandle(of);
  }
  hide_progress_bar();
  MessageBox(hwnd, a_success, appname, MB_ICONINFORMATION|MB_OK);
  ExitProcess(0);
  return true;
}

//----------------------------------------------------------------
BOOL CALLBACK DlgProc(HWND hwnd, UINT message, WPARAM wp, LPARAM )
{
  char phrase[MAXSTR];
  phrase[0] = '\0';
  static HWND child = 0;
  switch ( message )
  {
    case WM_INITDIALOG:
      {
        RECT rect;
        SendDlgItemMessage(hwnd, IDC_EDIT1, EM_SETLIMITTEXT, sizeof(phrase)-1, 0);
        SetDlgItemText(hwnd, IDC_EDIT1, phrase);
        GetWindowRect(hwnd, &rect); 
        if ( h->msglen )
          child = create_hint(hinst, hwnd, rect.right, rect.top, h->msg());
      }  
      return TRUE;

    case WM_COMMAND:
      switch ( LOWORD(wp) )
      {
        case IDOK:
          GetDlgItemText(hwnd, IDC_EDIT1, phrase, MAXSTR);
          if ( process_files(hwnd, phrase) )
            EndDialog(h, 1);
          else  
            SetDlgItemText(hwnd, IDC_EDIT1, "");
          return TRUE;
        case IDCANCEL:
          EndDialog(hwnd, 0);
          return TRUE;
        case IDC_BITMAP:
          ShellExecute(hwnd, "open", url, NULL, NULL, SW_SHOWDEFAULT);
          return TRUE;  
      }
      break;

    case WM_MOVE:
      if ( child )
      {
        RECT rect;
        GetWindowRect(hwnd, &rect);
        SetWindowPos(child, 0,
                rect.right, rect.top,
                0, 0, 
                SWP_NOSIZE|SWP_NOOWNERZORDER);
      }  
      break;
/*      
    case WM_DRAWITEM:
      {
//        int id = UINT(wp);
        LPDRAWITEMSTRUCT s = LPDRAWITEMSTRUCT(lp);
        SelectObject(s->hDC, f);
        SetTextColor(s->hDC, RGB(0, 0, 0xFF));
        TextOut(s->hDC, 0, 0, url, strlen(url));
      }
      break;
*/
    case WM_DESTROY:
      PostQuitMessage(0);
      break;  
        
  }
  return FALSE;
}

//----------------------------------------------------------------
int PASCAL WinMain(HINSTANCE hCurInstance,
            HINSTANCE, LPSTR lpCmdLine, int nCmdShow)
{
  UNREFERENCED_PARAMETER(lpCmdLine);
  UNREFERENCED_PARAMETER(nCmdShow);
  hinst = hCurInstance;  // save instance handle

  InitCommonControls();
  
  h  = get_ct();
  h2 = h->h2();
  crc32(NULL, 0);                                   // initialize crc
  ulong c32 = crc32(h->crc_start(), h->crc_len());  // and calc crc
  if ( h->crc32 != c32 )
  {
//    warning("h->crc32=%08lX now=%08lX size=%d", h->crc32, c32, h->size);
    corrupt();
  }

  DialogBox(hinst, TEXT("IDD_DIALOG1"), NULL, (DLGPROC)DlgProc);
  
  return 0;
}

