//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include <shlobj.hpp>

#include "fish.h"
#include "unit1.h"
#include "unit2.h"
#include "Option.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TFOption *FOption;
//---------------------------------------------------------------------------
__fastcall TFOption::TFOption(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TFOption::Button4Click(TObject *Sender)
{
  Application->HelpContext(HelpContext);
}

//---------------------------------------------------------------------------

void __fastcall TFOption::Button1Click(TObject *Sender)
{
  char sfolder[MAX_PATH];
  if ( BrowseForFolder(Handle, Label1->Caption.c_str(), sfolder) )
  {
    int len = strlen(sfolder);
    if ( sfolder[len-1] != '\\' )
    {
      sfolder[len] = '\\';
      sfolder[len+1] = '\0';
    }
    folder->Text = sfolder;
  }
}

//---------------------------------------------------------------------------
void __fastcall TFOption::savephraseClick(TObject *Sender)
{
   AnsiString &phrase = askphrase->Edit1->Text;
   if ( savephrase->Checked
      && phrase.Length() == 0 )
   {
     askphrase->CheckBox1->Checked = true;
     if ( askphrase->ShowModal() != mrOk )
     {
       savephrase->Checked = false;
       askphrase->CheckBox1->Checked = false;
     }
   }
}

//---------------------------------------------------------------------------
void __fastcall TForm1::OptionsExecute(TObject *Sender)
{
  FOption->folder->Text = encrypted_folder;
  FOption->ctray->Checked = ctray;
  FOption->savephrase->Checked = askphrase->CheckBox1->Checked;
  bool autorun = autorun_present();
  bool sendto  = sendto_present();
  FOption->autorun->Checked = autorun;
  FOption->sendto->Checked = sendto;
  if ( FOption->ShowModal() == mrOk )
  {
    bool repopulate = strcmp(encrypted_folder, FOption->folder->Text.c_str());
    strcpy(encrypted_folder, FOption->folder->Text.c_str());
    int len = strlen(encrypted_folder);
    if ( encrypted_folder[len-1] != '\\' )
    {
      encrypted_folder[len] = '\\';
      encrypted_folder[len+1] = '\0';
    }
    ctray = FOption->ctray->Checked;
    askphrase->CheckBox1->Checked = FOption->savephrase->Checked;
    if ( FOption->autorun->Checked != autorun ) correct_autorun(!autorun);
    if ( FOption->sendto->Checked != sendto ) correct_sendto(!sendto);
    write_config(askphrase->CheckBox1->Checked,
                 ctray,
                 askphrase->Edit1->Text.c_str());
    cfg_folder(encrypted_folder);
    if ( repopulate ) populate_list(encrypted_folder);
  }
}
bool __fastcall TFOption::FormHelp(WORD Command, int Data, bool &CallHelp)
{
  provide_help();
  CallHelp = false;
  return false;
}                
//---------------------------------------------------------------------------

