//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop
#include "fish.h"
#include "unit1.h"

USERES("acrypt.res");
USEFORM("Unit1.cpp", Form1);
USEUNIT("common.cpp");
USEUNIT("MD5.cpp");
USEUNIT("encrypt.cpp");
USEFORM("Unit2.cpp", askphrase);
USEUNIT("random.cpp");
USEUNIT("TWOFISH2.cpp");
USEFORM("Unit3.cpp", Form3);
USEUNIT("config.cpp");
USEUNIT("Zip.cpp");
USEFORM("OKCANCL1.cpp", OKBottomDlg);
USEFORM("Option.cpp", FOption);
USERC("stub.rc");
//---------------------------------------------------------------------------
char appname[MAXSTR] = "aCrypt";
HANDLE mail;
HINSTANCE hinst;
//---------------------------------------------------------------------------
AnsiString GetLongFileName(AnsiString filename)
{
  TSearchRec sr;
  if ( FindFirst(filename, faAnyFile, sr) == 0 )
    filename = ExtractFilePath(filename)+sr.Name;
  FindClose(sr);
  return filename;
}

//---------------------------------------------------------------------------
WINAPI WinMain(HINSTANCE h, HINSTANCE, LPSTR, int)
{
        hinst = h;
        // Create a named mail slot at the beginning
        // If we can't create the slot is means that another copy of
        // aCrypt is already running. Restore the old copy,
        // pass the files to encrypt to it and quit.
        static const char MailSlot[] = "\\\\.\\mailslot\\Encryptor";
        mail = CreateMailslot(MailSlot,
                                  0,       // any message size
                                  0,       // immediate read
                                  NULL);   // no security attributes
        if ( GetLastError() == ERROR_ALREADY_EXISTS )
        {
            // Yes, the old instance already exists
            Application->Title = "";
            // Find the old instance
            HWND hPrevApp = ::FindWindow(NULL, appname);
            if(hPrevApp)
            {
              // found it, send the command line information to it
              HANDLE c = CreateFile(MailSlot,
                                    GENERIC_WRITE,
                                    FILE_SHARE_READ,
                                    NULL,
                                    OPEN_EXISTING,
                                    FILE_ATTRIBUTE_NORMAL,
                                    NULL);
              if ( c != INVALID_HANDLE_VALUE )
              {
                int end = ParamCount();
                int start = 1;
                if ( ParamStr(1) == "-m" ) start++;
                DWORD written;
                AnsiString files = "";
                while ( start <= end )
                {
                  if ( files.c_str()[0] != 0 ) files += ";";
                  files += GetLongFileName(ParamStr(start));
                  start++;
                }
                DWORD len = files.Length()+1;
                WriteFile(c, &len, sizeof(len), &written, NULL);
                WriteFile(c, files.c_str(), len, &written, NULL);
//                int code =
                PostMessage(hPrevApp, WM_SYSCOMMAND, SC_RESTORE, 0);
//                int code =
                PostMessage(hPrevApp, WM_SENTFILES, 0, 0);
//                int code = PostMessage(hPrevApp, WM_DROPFILES, WPARAM(INVALID_HANDLE_VALUE), 0);
//                warning("code=%d", code);
                CloseHandle(c);
              }
            }
            return 0;
        }

        try
        {
                 Application->Initialize();
                 Application->Title = "aCrypt";
                 Application->HelpFile = "acrypt.hlp";
                 Application->CreateForm(__classid(TForm1), &Form1);
                 Application->CreateForm(__classid(Taskphrase), &askphrase);
                 Application->CreateForm(__classid(TForm3), &Form3);
                 Application->CreateForm(__classid(TOKBottomDlg), &OKBottomDlg);
                 Application->CreateForm(__classid(TFOption), &FOption);
                 // if we run the first time, offer the user to configure the program
                 if ( !config_ok ) Form1->OptionsExecute(NULL);
                 int cnt = ParamCount();
                 AnsiString files = "";
                 for (int i=1; i <= cnt; i++)
                 {
                   if ( ParamStr(i) == "-m" )     // -m means start minimized
                   {
                     Application->Minimize();
                     ShowWindow(Application->Handle, SW_HIDE);
                     continue;
                   }
                   if ( files.c_str()[0] != 0 ) files += ";";
                   files += GetLongFileName(ParamStr(i));
                 }
                 encrypt(files.c_str());
                 Application->Run();
        }
        catch (Exception &exception)
        {
                 Application->ShowException(&exception);
        }

        CloseHandle(mail);

        return 0;
}
//---------------------------------------------------------------------------
