#include <windows.h>

char appname[] = "Decrypt";
char wndclass[] = "DecryptorWindow";

HINSTANCE hinst;
HWND hwndMain;

//----------------------------------------------------------------
LRESULT CALLBACK WndProc(

    HWND hwnd,	// handle of window
    UINT message,	// message identifier
    WPARAM wParam,	// first message parameter
    LPARAM lParam 	// second message parameter
   )
{
	HDC hdc;
   PAINTSTRUCT ps;
   RECT rect;
   static int cxClient;	// client area dimensions
   static int cyClient;

   switch ( message )
   {
     case WM_CREATE:
       PlaySound( TEXT("ding.wav"), NULL, SND_FILENAME|SND_ASYNC);
       return 0;

     // window size is changed
     case WM_SIZE:
       cxClient = LOWORD(lParam);
       cyClient = HIWORD(lParam);
       return 0;

     case WM_PAINT:
       hdc = BeginPaint(hwnd, &ps);
       GetClientRect(hwnd, &rect);
       SetBkMode(hdc, TRANSPARENT);
       SetTextColor(hdc, 0x0000FF);
       DrawText(hdc, TEXT("Hello, world!"), -1, &rect,
         DT_SINGLELINE|DT_CENTER|DT_VCENTER);
       EndPaint(hwnd, &ps);
       return 0;

     case WM_DESTROY:
       PostQuitMessage(0);
       return 0;
  }
  return DefWindowProc(hwnd, message, wParam, lParam);
}
#if 0

//----------------------------------------------------------------
int PASCAL WinMain(HINSTANCE hCurInstance,
            HINSTANCE hPrevInstance, LPSTR lpCmdLine, int nCmdShow)
{
    MSG msg;
    WNDCLASS wc;
    UNREFERENCED_PARAMETER(lpCmdLine);

    // Register the window class for the main window.

    hinst = hCurInstance;  // save instance handle

        wc.style = CS_HREDRAW|CS_VREDRAW;
        wc.lpfnWndProc = (WNDPROC) WndProc;
        wc.cbClsExtra = 0;
        wc.cbWndExtra = 0;
        wc.hInstance = hCurInstance;

        wc.hIcon = LoadIcon(hinst, MAKEINTRESOURCE(1));
        wc.hCursor = LoadCursor(NULL, IDC_ARROW);
        wc.hbrBackground = GetStockObject(LTGRAY_BRUSH);
        wc.lpszMenuName =  "MainMenu";
        wc.lpszClassName = wndclass;

        if (!RegisterClass(&wc))
            return FALSE;

    // Create the main window.

    hwndMain = CreateWindow(wndclass, appname,
        WS_OVERLAPPEDWINDOW,
        CW_USEDEFAULT,
        CW_USEDEFAULT,
        CW_USEDEFAULT,
        CW_USEDEFAULT,
        (HWND) NULL,
        (HMENU) NULL, hinst, (LPVOID) NULL);

    // If the main window cannot be created, terminate
    // the application.

    if (!hwndMain)
        return FALSE;

    // Show the window and paint its contents.

    ShowWindow(hwndMain, nCmdShow);
    UpdateWindow(hwndMain);

    // Start the message loop.

    while (GetMessage(&msg, NULL, 0, 0))

    {
        TranslateMessage(&msg);
        DispatchMessage(&msg);
    }

    // Return the exit code to Windows.

    return msg.wParam;

//MessageBox(hCurInstance, "Hello, world!", appname, MB_OK);
//  MessageBox(NULL, "Hello, world!", appname, MB_OK);
}

#endif

//----------------------------------------------------------------
BOOL CALLBACK DlgProc(HWND h, UINT message, WPARAM wp, LPARAM lp)
{
  UNREFERENCED_PARAMETER(lp);
  switch ( message )
  {
    case WM_INITDIALOG:
      return TRUE;

    case WM_COMMAND:
      switch ( LOWORD(wp) )
      {
        case IDOK:
        case IDCANCEL:
          EndDialog(h, 0);
          return TRUE;
      }
      break;
  }
  return FALSE;
}

//----------------------------------------------------------------
int PASCAL WinMain(HINSTANCE hCurInstance,
            HINSTANCE hPrevInstance, LPSTR lpCmdLine, int nCmdShow)
{
    MSG msg;
    WNDCLASS wc;
    UNREFERENCED_PARAMETER(lpCmdLine);

    // Register the window class for the main window.


    hinst = hCurInstance;  // save instance handle
/*
        wc.style = CS_HREDRAW|CS_VREDRAW;
        wc.lpfnWndProc = (WNDPROC) WndProc;
        wc.cbClsExtra = 0;
        wc.cbWndExtra = 0;
        wc.hInstance = hCurInstance;

        wc.hIcon = LoadIcon(hinst, MAKEINTRESOURCE(1));
        wc.hCursor = LoadCursor(NULL, IDC_ARROW);
        wc.hbrBackground = GetStockObject(LTGRAY_BRUSH);
        wc.lpszMenuName =  "MainMenu";
        wc.lpszClassName = wndclass;

        if (!RegisterClass(&wc))
            return FALSE;

    // Create the main window.

    HWND hwndMain = CreateWindow(wndclass, appname,
        WS_OVERLAPPEDWINDOW,
        CW_USEDEFAULT,
        CW_USEDEFAULT,
        CW_USEDEFAULT,
        CW_USEDEFAULT,
        (HWND) NULL,
        (HMENU) NULL, hinst, (LPVOID) NULL);

    // If the main window cannot be created, terminate
    // the application.

    if (!hwndMain)
        return FALSE;
*/
    DialogBox(hinst, MAKEINTRESOURCE(1), NULL, (DLGPROC)DlgProc);
    return 0;
}


