//---------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "fish.h"
#include "Unit1.h"
#include "Unit2.h"
//---------------------------------------------------------------------
#pragma resource "*.dfm"
Taskphrase *askphrase;
//---------------------------------------------------------------------
__fastcall Taskphrase::Taskphrase(TComponent* AOwner)
	: TOKBottomDlg(AOwner)
{
}

//---------------------------------------------------------------------
void __fastcall Taskphrase::HelpBtnClick(TObject *Sender)
{
  	Application->HelpContext(HelpContext);
}
//---------------------------------------------------------------------
void __fastcall Taskphrase::check_phrases(void)
{
  AnsiString &s1 = Edit1->Text;
  AnsiString &s2 = Edit2->Text;
  OKBtn->Enabled = (s1.Length() >= 8)
                &&  s1 == s2;
}

//---------------------------------------------------------------------------
void __fastcall Taskphrase::Edit1Change(TObject *Sender)
{
  check_phrases();
}
//---------------------------------------------------------------------------

void __fastcall Taskphrase::Edit2Change(TObject *Sender)
{
  check_phrases();
}

//---------------------------------------------------------------------------
void __fastcall Taskphrase::FormCreate(TObject *Sender)
{
  bool save;
  char phrase[MAXSTR];
  read_config(&save, phrase);
  askphrase->CheckBox1->Checked = save;
  if ( save )
  {
    askphrase->Edit1->Text = phrase;
    askphrase->Edit2->Text = phrase;
  }
}

//---------------------------------------------------------------------------

bool __fastcall Taskphrase::FormHelp(WORD Command, int Data,
      bool &CallHelp)
{
  provide_help();
  CallHelp = false;
  return false;
}
//---------------------------------------------------------------------------

